> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nami.cloud/llms.txt
> Use this file to discover all available pages before exploring further.

# Delete Bucket

> Delete an empty S3 bucket

<Note>
  The bucket must be empty before it can be deleted. You need appropriate permissions to delete buckets in your account.
</Note>

## Delete Bucket

Deletes an empty bucket. All objects (including all object versions and delete markers) in the bucket must be deleted before the bucket itself can be deleted.

### Base URL

```bash theme={null}
https://${bucketname}.storage.nami.cloud
```

### Headers

<ParamField header="x-amz-mfa" optional>
  The MFA authentication code when MFA Delete is enabled
</ParamField>

### Request Examples

<RequestExample>
  ```bash Bash theme={null}
  curl -X DELETE "https://mybucket.storage.nami.cloud/" \
    -H "Authorization: AWS4-HMAC-SHA256 Credential=AKIAIOSFODNN7EXAMPLE/20231028/us-east-1/s3/aws4_request, SignedHeaders=host;x-amz-date, Signature=fe5f80f77d5fa3beca038a248ff027d0445342fe2855ddc963176630326f1024"
  ```

  ```python Python theme={null}
  import boto3

  s3_client = boto3.client('s3',
      endpoint_url='https://storage.nami.cloud',
      aws_access_key_id='YOUR_ACCESS_KEY',
      aws_secret_access_key='YOUR_SECRET_KEY'
  )

  s3_client.delete_bucket(Bucket='mybucket')
  ```

  ```javascript Node.js theme={null}
  import { S3Client, DeleteBucketCommand } from "@aws-sdk/client-s3";

  const client = new S3Client({
    endpoint: "https://storage.nami.cloud",
    credentials: {
      accessKeyId: "YOUR_ACCESS_KEY",
      secretAccessKey: "YOUR_SECRET_KEY",
    },
  });

  async function deleteBucket() {
    const command = new DeleteBucketCommand({
      Bucket: "mybucket"
    });

    try {
      const response = await client.send(command);
      console.log("Bucket deleted:", response);
    } catch (err) {
      console.error("Error:", err);
    }
  }

  deleteBucket();
  ```

  ```go Golang theme={null}
  package main

  import (
      "github.com/aws/aws-sdk-go/aws"
      "github.com/aws/aws-sdk-go/aws/credentials"
      "github.com/aws/aws-sdk-go/aws/session"
      "github.com/aws/aws-sdk-go/service/s3"
  )

  func main() {
      sess := session.Must(session.NewSession(&aws.Config{
          Endpoint:    aws.String("https://storage.nami.cloud"),
          Region:      aws.String("us-east-1"),
          Credentials: credentials.NewStaticCredentials("YOUR_ACCESS_KEY", "YOUR_SECRET_KEY", ""),
      }))

      s3Client := s3.New(sess)

      _, err := s3Client.DeleteBucket(&s3.DeleteBucketInput{
          Bucket: aws.String("mybucket"),
      })
      if err != nil {
          panic(err)
      }
  }
  ```

  ```rust Rust theme={null}
  use aws_sdk_s3::{Client, Config};
  use aws_config::credentials::StaticCredentialsProvider;
  use aws_types::region::Region;
  use tokio;

  #[tokio::main]
  async fn main() -> Result<(), Box<dyn std::error::Error>> {
      let credentials = StaticCredentialsProvider::new(
          "YOUR_ACCESS_KEY".to_string(),
          "YOUR_SECRET_KEY".to_string(),
          None,
      );

      let config = Config::builder()
          .endpoint_url("https://storage.nami.cloud")
          .region(Region::new("us-east-1"))
          .credentials_provider(credentials)
          .build();

      let client = Client::from_conf(config);

      client
          .delete_bucket()
          .bucket("mybucket")
          .send()
          .await?;

      println!("Bucket deleted successfully!");
      Ok(())
  }
  ```
</RequestExample>

### Response Example

```json theme={null}
HTTP/1.1 204 No Content
x-amz-id-2: JuKZqmXuiwFeDQxhD7M8KtsKobSzWA1QEjLbTMTagkKdBX2z7Il/jGhDeJ3j6s80
x-amz-request-id: 32FE2CEB32F5EE25
Date: Wed, 28 Oct 2023 22:32:00 GMT
Server: Nami Cloud
```


## OpenAPI

````yaml DELETE /
openapi: 3.0.1
info:
  title: Nami Cloud Storage API
  description: S3 compatible storage service API documentation
  version: 1.0.0
servers:
  - url: https://{bucketName}.storage.nami.cloud
    variables:
      bucketName:
        default: mybucket
        description: The name of the bucket
security:
  - awsV4: []
paths:
  /:
    delete:
      tags:
        - Bucket Operations
      summary: Delete Bucket
      description: Deletes an empty bucket
      responses:
        '204':
          description: Bucket deleted successfully
        '404':
          description: Bucket not found
          content:
            application/xml:
              schema:
                $ref: '#/components/schemas/Error'
components:
  schemas:
    Error:
      type: object
      properties:
        Code:
          type: string
        Message:
          type: string
        RequestId:
          type: string
  securitySchemes:
    awsV4:
      type: apiKey
      name: Authorization
      in: header
      description: AWS Signature Version 4

````